# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from mir_actions/MirMoveBaseActionGoal.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import actionlib_msgs.msg
import genpy
import geometry_msgs.msg
import mir_actions.msg
import nav_msgs.msg
import std_msgs.msg

class MirMoveBaseActionGoal(genpy.Message):
  _md5sum = "914bd5ff203b40ccedbfd67f69a6ec0d"
  _type = "mir_actions/MirMoveBaseActionGoal"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalID goal_id
MirMoveBaseGoal goal

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: mir_actions/MirMoveBaseGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
#goal definition
#move type
int16 BASE_MOVE = 0
int16 GLOBAL_MOVE = 1
int16 RELATIVE_MOVE = 2
int16 RELATIVE_MARKER_MOVE = 3
int16 DOCKING_MOVE = 4
int16 DOCKING_GLOBAL_MOVE = 5
int16 move_task

#shared parameters
geometry_msgs/PoseStamped target_pose

#global move parameters
float64 goal_dist_threshold
float64 goal_orientation_threshold
nav_msgs/Path path
float32 max_plan_time
bool clear_costmaps
bool pause_command
bool continue_command

#relative move parameters
float64 yaw
bool collision_detection
bool collision_avoidance
float64 disable_collision_check_dist
float64 max_linear_speed
float64 max_rotational_speed
float64 pid_dist_offset
float64 target_offset
bool only_collision_detection
float64 timeout

#docking move parameters
int32 pattern_type
int32 pattern_value
bool only_track
bool same_goal
string pose_frame
geometry_msgs/Pose2D pose
geometry_msgs/Pose2D offset
float64 bar_length
float64 bar_distance
float64 shelf_leg_asymmetry_x
float64 tolerance


================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: nav_msgs/Path
#An array of poses that represents a Path for a robot to follow
Header header
geometry_msgs/PoseStamped[] poses

================================================================================
MSG: geometry_msgs/Pose2D
# Deprecated
# Please use the full 3D pose.

# In general our recommendation is to use a full 3D representation of everything and for 2D specific applications make the appropriate projections into the plane for their calculations but optimally will preserve the 3D information during processing.

# If we have parallel copies of 2D datatypes every UI and other pipeline will end up needing to have dual interfaces to plot everything. And you will end up with not being able to use 3D tools for 2D use cases even if they're completely valid, as you'd have to reimplement it with different inputs and outputs. It's not particularly hard to plot the 2D pose or compute the yaw error for the Pose message and there are already tools and libraries that can do this for you.


# This expresses a position and orientation on a 2D manifold.

float64 x
float64 y
float64 theta
"""
  __slots__ = ['header','goal_id','goal']
  _slot_types = ['std_msgs/Header','actionlib_msgs/GoalID','mir_actions/MirMoveBaseGoal']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,goal_id,goal

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MirMoveBaseActionGoal, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.goal_id is None:
        self.goal_id = actionlib_msgs.msg.GoalID()
      if self.goal is None:
        self.goal = mir_actions.msg.MirMoveBaseGoal()
    else:
      self.header = std_msgs.msg.Header()
      self.goal_id = actionlib_msgs.msg.GoalID()
      self.goal = mir_actions.msg.MirMoveBaseGoal()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.goal_id.stamp.secs, _x.goal_id.stamp.nsecs))
      _x = self.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_h3I().pack(_x.goal.move_task, _x.goal.target_pose.header.seq, _x.goal.target_pose.header.stamp.secs, _x.goal.target_pose.header.stamp.nsecs))
      _x = self.goal.target_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_9d3I().pack(_x.goal.target_pose.pose.position.x, _x.goal.target_pose.pose.position.y, _x.goal.target_pose.pose.position.z, _x.goal.target_pose.pose.orientation.x, _x.goal.target_pose.pose.orientation.y, _x.goal.target_pose.pose.orientation.z, _x.goal.target_pose.pose.orientation.w, _x.goal.goal_dist_threshold, _x.goal.goal_orientation_threshold, _x.goal.path.header.seq, _x.goal.path.header.stamp.secs, _x.goal.path.header.stamp.nsecs))
      _x = self.goal.path.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.goal.path.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.goal.path.poses:
        _v1 = val1.header
        _x = _v1.seq
        buff.write(_get_struct_I().pack(_x))
        _v2 = _v1.stamp
        _x = _v2
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v3 = val1.pose
        _v4 = _v3.position
        _x = _v4
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v5 = _v3.orientation
        _x = _v5
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_get_struct_f3Bd2B5dBd2i2B().pack(_x.goal.max_plan_time, _x.goal.clear_costmaps, _x.goal.pause_command, _x.goal.continue_command, _x.goal.yaw, _x.goal.collision_detection, _x.goal.collision_avoidance, _x.goal.disable_collision_check_dist, _x.goal.max_linear_speed, _x.goal.max_rotational_speed, _x.goal.pid_dist_offset, _x.goal.target_offset, _x.goal.only_collision_detection, _x.goal.timeout, _x.goal.pattern_type, _x.goal.pattern_value, _x.goal.only_track, _x.goal.same_goal))
      _x = self.goal.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10d().pack(_x.goal.pose.x, _x.goal.pose.y, _x.goal.pose.theta, _x.goal.offset.x, _x.goal.offset.y, _x.goal.offset.theta, _x.goal.bar_length, _x.goal.bar_distance, _x.goal.shelf_leg_asymmetry_x, _x.goal.tolerance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.goal_id is None:
        self.goal_id = actionlib_msgs.msg.GoalID()
      if self.goal is None:
        self.goal = mir_actions.msg.MirMoveBaseGoal()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.goal_id.stamp.secs, _x.goal_id.stamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal_id.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.goal_id.id = str[start:end]
      _x = self
      start = end
      end += 14
      (_x.goal.move_task, _x.goal.target_pose.header.seq, _x.goal.target_pose.header.stamp.secs, _x.goal.target_pose.header.stamp.nsecs,) = _get_struct_h3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal.target_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.goal.target_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 84
      (_x.goal.target_pose.pose.position.x, _x.goal.target_pose.pose.position.y, _x.goal.target_pose.pose.position.z, _x.goal.target_pose.pose.orientation.x, _x.goal.target_pose.pose.orientation.y, _x.goal.target_pose.pose.orientation.z, _x.goal.target_pose.pose.orientation.w, _x.goal.goal_dist_threshold, _x.goal.goal_orientation_threshold, _x.goal.path.header.seq, _x.goal.path.header.stamp.secs, _x.goal.path.header.stamp.nsecs,) = _get_struct_9d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal.path.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.goal.path.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.goal.path.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        _v6 = val1.header
        start = end
        end += 4
        (_v6.seq,) = _get_struct_I().unpack(str[start:end])
        _v7 = _v6.stamp
        _x = _v7
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v6.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v6.frame_id = str[start:end]
        _v8 = val1.pose
        _v9 = _v8.position
        _x = _v9
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v10 = _v8.orientation
        _x = _v10
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.goal.path.poses.append(val1)
      _x = self
      start = end
      end += 76
      (_x.goal.max_plan_time, _x.goal.clear_costmaps, _x.goal.pause_command, _x.goal.continue_command, _x.goal.yaw, _x.goal.collision_detection, _x.goal.collision_avoidance, _x.goal.disable_collision_check_dist, _x.goal.max_linear_speed, _x.goal.max_rotational_speed, _x.goal.pid_dist_offset, _x.goal.target_offset, _x.goal.only_collision_detection, _x.goal.timeout, _x.goal.pattern_type, _x.goal.pattern_value, _x.goal.only_track, _x.goal.same_goal,) = _get_struct_f3Bd2B5dBd2i2B().unpack(str[start:end])
      self.goal.clear_costmaps = bool(self.goal.clear_costmaps)
      self.goal.pause_command = bool(self.goal.pause_command)
      self.goal.continue_command = bool(self.goal.continue_command)
      self.goal.collision_detection = bool(self.goal.collision_detection)
      self.goal.collision_avoidance = bool(self.goal.collision_avoidance)
      self.goal.only_collision_detection = bool(self.goal.only_collision_detection)
      self.goal.only_track = bool(self.goal.only_track)
      self.goal.same_goal = bool(self.goal.same_goal)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal.pose_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.goal.pose_frame = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.goal.pose.x, _x.goal.pose.y, _x.goal.pose.theta, _x.goal.offset.x, _x.goal.offset.y, _x.goal.offset.theta, _x.goal.bar_length, _x.goal.bar_distance, _x.goal.shelf_leg_asymmetry_x, _x.goal.tolerance,) = _get_struct_10d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.goal_id.stamp.secs, _x.goal_id.stamp.nsecs))
      _x = self.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_h3I().pack(_x.goal.move_task, _x.goal.target_pose.header.seq, _x.goal.target_pose.header.stamp.secs, _x.goal.target_pose.header.stamp.nsecs))
      _x = self.goal.target_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_9d3I().pack(_x.goal.target_pose.pose.position.x, _x.goal.target_pose.pose.position.y, _x.goal.target_pose.pose.position.z, _x.goal.target_pose.pose.orientation.x, _x.goal.target_pose.pose.orientation.y, _x.goal.target_pose.pose.orientation.z, _x.goal.target_pose.pose.orientation.w, _x.goal.goal_dist_threshold, _x.goal.goal_orientation_threshold, _x.goal.path.header.seq, _x.goal.path.header.stamp.secs, _x.goal.path.header.stamp.nsecs))
      _x = self.goal.path.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.goal.path.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.goal.path.poses:
        _v11 = val1.header
        _x = _v11.seq
        buff.write(_get_struct_I().pack(_x))
        _v12 = _v11.stamp
        _x = _v12
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v11.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v13 = val1.pose
        _v14 = _v13.position
        _x = _v14
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v15 = _v13.orientation
        _x = _v15
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_get_struct_f3Bd2B5dBd2i2B().pack(_x.goal.max_plan_time, _x.goal.clear_costmaps, _x.goal.pause_command, _x.goal.continue_command, _x.goal.yaw, _x.goal.collision_detection, _x.goal.collision_avoidance, _x.goal.disable_collision_check_dist, _x.goal.max_linear_speed, _x.goal.max_rotational_speed, _x.goal.pid_dist_offset, _x.goal.target_offset, _x.goal.only_collision_detection, _x.goal.timeout, _x.goal.pattern_type, _x.goal.pattern_value, _x.goal.only_track, _x.goal.same_goal))
      _x = self.goal.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10d().pack(_x.goal.pose.x, _x.goal.pose.y, _x.goal.pose.theta, _x.goal.offset.x, _x.goal.offset.y, _x.goal.offset.theta, _x.goal.bar_length, _x.goal.bar_distance, _x.goal.shelf_leg_asymmetry_x, _x.goal.tolerance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.goal_id is None:
        self.goal_id = actionlib_msgs.msg.GoalID()
      if self.goal is None:
        self.goal = mir_actions.msg.MirMoveBaseGoal()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.goal_id.stamp.secs, _x.goal_id.stamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal_id.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.goal_id.id = str[start:end]
      _x = self
      start = end
      end += 14
      (_x.goal.move_task, _x.goal.target_pose.header.seq, _x.goal.target_pose.header.stamp.secs, _x.goal.target_pose.header.stamp.nsecs,) = _get_struct_h3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal.target_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.goal.target_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 84
      (_x.goal.target_pose.pose.position.x, _x.goal.target_pose.pose.position.y, _x.goal.target_pose.pose.position.z, _x.goal.target_pose.pose.orientation.x, _x.goal.target_pose.pose.orientation.y, _x.goal.target_pose.pose.orientation.z, _x.goal.target_pose.pose.orientation.w, _x.goal.goal_dist_threshold, _x.goal.goal_orientation_threshold, _x.goal.path.header.seq, _x.goal.path.header.stamp.secs, _x.goal.path.header.stamp.nsecs,) = _get_struct_9d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal.path.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.goal.path.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.goal.path.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        _v16 = val1.header
        start = end
        end += 4
        (_v16.seq,) = _get_struct_I().unpack(str[start:end])
        _v17 = _v16.stamp
        _x = _v17
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v16.frame_id = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v16.frame_id = str[start:end]
        _v18 = val1.pose
        _v19 = _v18.position
        _x = _v19
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v20 = _v18.orientation
        _x = _v20
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.goal.path.poses.append(val1)
      _x = self
      start = end
      end += 76
      (_x.goal.max_plan_time, _x.goal.clear_costmaps, _x.goal.pause_command, _x.goal.continue_command, _x.goal.yaw, _x.goal.collision_detection, _x.goal.collision_avoidance, _x.goal.disable_collision_check_dist, _x.goal.max_linear_speed, _x.goal.max_rotational_speed, _x.goal.pid_dist_offset, _x.goal.target_offset, _x.goal.only_collision_detection, _x.goal.timeout, _x.goal.pattern_type, _x.goal.pattern_value, _x.goal.only_track, _x.goal.same_goal,) = _get_struct_f3Bd2B5dBd2i2B().unpack(str[start:end])
      self.goal.clear_costmaps = bool(self.goal.clear_costmaps)
      self.goal.pause_command = bool(self.goal.pause_command)
      self.goal.continue_command = bool(self.goal.continue_command)
      self.goal.collision_detection = bool(self.goal.collision_detection)
      self.goal.collision_avoidance = bool(self.goal.collision_avoidance)
      self.goal.only_collision_detection = bool(self.goal.only_collision_detection)
      self.goal.only_track = bool(self.goal.only_track)
      self.goal.same_goal = bool(self.goal.same_goal)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.goal.pose_frame = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.goal.pose_frame = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.goal.pose.x, _x.goal.pose.y, _x.goal.pose.theta, _x.goal.offset.x, _x.goal.offset.y, _x.goal.offset.theta, _x.goal.bar_length, _x.goal.bar_distance, _x.goal.shelf_leg_asymmetry_x, _x.goal.tolerance,) = _get_struct_10d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_10d = None
def _get_struct_10d():
    global _struct_10d
    if _struct_10d is None:
        _struct_10d = struct.Struct("<10d")
    return _struct_10d
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_9d3I = None
def _get_struct_9d3I():
    global _struct_9d3I
    if _struct_9d3I is None:
        _struct_9d3I = struct.Struct("<9d3I")
    return _struct_9d3I
_struct_f3Bd2B5dBd2i2B = None
def _get_struct_f3Bd2B5dBd2i2B():
    global _struct_f3Bd2B5dBd2i2B
    if _struct_f3Bd2B5dBd2i2B is None:
        _struct_f3Bd2B5dBd2i2B = struct.Struct("<f3Bd2B5dBd2i2B")
    return _struct_f3Bd2B5dBd2i2B
_struct_h3I = None
def _get_struct_h3I():
    global _struct_h3I
    if _struct_h3I is None:
        _struct_h3I = struct.Struct("<h3I")
    return _struct_h3I
